﻿Namespace EIBData.DPT
    Public NotInheritable Class EIBDataDPT_20_011
        Inherits EIBDataDPT_20_Base

        Public Enum EIBDataDPT_20_011_Values
            NoFault = 0
            GeneralDeviceFault = 1
            CommunicationFault = 2
            ConfigurationFault = 3
            HardwareFault = 4
            SoftwareFault = 5
            InsufficientNonVolatileMemory = 6
            InsufficientVolatileMemory = 7
            MemoryAllocationCommandWithSize0Received = 8
            CRCError = 9
            WatchdogResetDetected = 10
            InvalidOPCodeDetected = 11
            GeneralProtectionFault = 12
            MaximalTableLengthExceeded = 13
            UndefinedLoadCommandReceived = 14
            GroupAddressTableIsNotSorted = 15
            InvalidConnectionNumber = 16
            InvalidGroupObjectNumber = 17
            GroupObjectTypeExceeded = 18
        End Enum

        Protected _value As EIBDataDPT_20_011_Values = Nothing


        Sub New(data As Byte())
            MyBase.New(data)

            _value = _valueBase
        End Sub

        Sub New(value As EIBDataDPT_20_011_Values)
            MyBase.New(value)

            _value = value
        End Sub


        Public Overrides Function ToInfoList() As List(Of EIB.InfoBase)
            Dim list As New List(Of EIB.InfoBase)

            list.Add(New EIB.Info("Type", DPT_Name))
            list.Add(New EIB.Info("Value", String.Format("{0} (0x{0:X})", _value)))

            Return list
        End Function

        Public Shared Shadows ReadOnly Property DPT_Name As String
            Get
                Return "DPT_ErrorClass_System"
            End Get
        End Property

        Public Shared Shadows ReadOnly Property DPT_Number As String
            Get
                Return "20.011"
            End Get
        End Property

        Public Overrides Function ToString() As String
            Return _value
        End Function

        Public Overloads ReadOnly Property Value As EIBDataDPT_20_011_Values
            Get
                Return _value
            End Get
        End Property
    End Class
End Namespace