﻿Namespace EIBData.DPT
    Public NotInheritable Class EIBDataDPT_20_014
        Inherits EIBDataDPT_20_Base

        Public Enum EIBDataDPT_20_014_Values
            Calm_NoWind = 0
            LightAir = 1
            LightBreeze = 2
            GentleBreeze = 3
            ModerateBreeze = 4
            FreshBreeze = 5
            StrongBreeze = 6
            NearGale_ModerateGale = 7
            FreshGale = 8
            StrongGale = 9
            WholeGale_Storm = 10
            ViolentStorm = 11
            Hurricane = 12
        End Enum

        Protected _value As EIBDataDPT_20_014_Values = Nothing


        Sub New(data As Byte())
            MyBase.New(data)

            _value = _valueBase
        End Sub

        Sub New(value As EIBDataDPT_20_014_Values)
            MyBase.New(value)

            _value = value
        End Sub


        Public Overrides Function ToInfoList() As List(Of EIB.InfoBase)
            Dim list As New List(Of EIB.InfoBase)

            list.Add(New EIB.Info("Type", DPT_Name))
            list.Add(New EIB.Info("Value", String.Format("{0} (0x{0:X})", _value)))

            Return list
        End Function

        Public Shared Shadows ReadOnly Property DPT_Name As String
            Get
                Return "DPT_Beaufort_Wind_Force_Scale"
            End Get
        End Property

        Public Shared Shadows ReadOnly Property DPT_Number As String
            Get
                Return "20.014"
            End Get
        End Property

        Public Overrides Function ToString() As String
            Return _value
        End Function

        Public Overloads ReadOnly Property Value As EIBDataDPT_20_014_Values
            Get
                Return _value
            End Get
        End Property
    End Class
End Namespace