﻿Namespace EIBData.DPT
    Public NotInheritable Class EIBDataDPT_9_026
        Inherits EIBDataDPT_9_Base


        Sub New(data As Byte())
            MyBase.New(data)

            If _value < -671088.64 Then Throw New EIB.Exceptions.EIBDataDecodeException("")
            If _value > 670760.96 Then Throw New EIB.Exceptions.EIBDataDecodeException("")
        End Sub

        Sub New(value As Double)
            MyBase.New(value)

            If value < -671088.64 Then Throw New EIB.Exceptions.EIBDataEncodeException("")
            If value > 670760.96 Then Throw New EIB.Exceptions.EIBDataEncodeException("")
        End Sub


        Public Shared Shadows ReadOnly Property DPT_Name As String
            Get
                Return "DPT_Rain_Amount"
            End Get
        End Property

        Public Shared Shadows ReadOnly Property DPT_Number As String
            Get
                Return "9.026"
            End Get
        End Property

        Public Overrides Function ToString() As String
            Return String.Format("{0:F2} l/m²", _value)
        End Function
    End Class
End Namespace