﻿Namespace EIBData.EIS
    Public NotInheritable Class EIBDataEIS_13
        Inherits EIBDataEIS_Base

        Private _value As Char = Nothing


        Sub New(data As Byte())
            If Not CanEncode(data) Then Throw New EIB.Exceptions.EIBDataDecodeException("")
            If data(1) > 127 Then Throw New EIB.Exceptions.EIBDataDecodeException("")

            MyBase._data = data
            _value = System.Text.Encoding.ASCII.GetChars(New Byte() {data(1)})(0)
        End Sub

        Sub New(value As Char)
            _value = value
            MyBase._data = New Byte() {0, System.Text.Encoding.ASCII.GetBytes(New Char() {_value})(0)}
        End Sub


        Public Overrides Function CanEncode(data() As Byte) As Boolean
            Return data IsNot Nothing AndAlso data.Length = EIS_OctetLength
        End Function

        Public Overrides Function ToString() As String
            Return _value
        End Function

        Public Overrides Function ToObject() As Object()
            Return New Object() {_value}
        End Function

        Public Overrides ReadOnly Property ObjectType As System.Type()
            Get
                Return New Type() {GetType(Char)}
            End Get
        End Property

        Public Overrides Function ToInfoList() As List(Of EIB.InfoBase)
            Dim list As New List(Of EIB.InfoBase)

            list.Add(New EIB.Info("Type", EIS_Name))
            list.Add(New EIB.Info("Value", _value))

            Return list
        End Function

        Public Shared Shadows ReadOnly Property EIS_OctetLength As Byte
            Get
                Return 2
            End Get
        End Property

        Public Shared Shadows ReadOnly Property EIS_Name As String
            Get
                Return "EIS 13"
            End Get
        End Property


        Public ReadOnly Property Value As Char
            Get
                Return _value
            End Get
        End Property
    End Class
End Namespace