﻿Namespace EIBData.EIS
    Public NotInheritable Class EIBDataEIS_2_Position
        Inherits EIBDataEIS_2_Base

        Protected _position As Boolean = Nothing


        Sub New(data As Byte())
            If Not CanEncode(data) Then Throw New EIB.Exceptions.EIBDataDecodeException("")

            MyBase._data = data
            _position = data(0) And &H1
        End Sub

        Sub New(position As Boolean)
            _position = position
            MyBase._data = New Byte() {If(_position, 1, 0)}
        End Sub


        Public Overrides Function CanEncode(data() As Byte) As Boolean
            Return data IsNot Nothing AndAlso data.Length = EIS_OctetLength
        End Function

        Public Overrides Function ToString() As String
            Return If(_position, 1, 0)
        End Function

        Public Overrides Function ToObject() As Object()
            Return New Object() {_position}
        End Function

        Public Overrides ReadOnly Property ObjectType As System.Type()
            Get
                Return New Type() {GetType(Boolean)}
            End Get
        End Property

        Public Overrides Function ToInfoList() As List(Of EIB.InfoBase)
            Dim list As New List(Of EIB.InfoBase)

            list.Add(New EIB.Info("Type", EIS_Name))
            list.Add(New EIB.Info("Position", _position))

            Return list
        End Function

        Public Shared Shadows ReadOnly Property EIS_OctetLength As Byte
            Get
                Return 1
            End Get
        End Property

        Public Shared Shadows ReadOnly Property EIS_Name As String
            Get
                Return "EIS 2 (Position)"
            End Get
        End Property

        Public ReadOnly Property Position As Boolean
            Get
                Return _position
            End Get
        End Property
    End Class
End Namespace